#ifndef ALGA_HELPERS_VESA_DMTS_H
#define ALGA_HELPERS_VESA_DMTS_H
/*
  author Sylvain Bertrand <sylvain.bertrand@gmail.com>
  Protected by linux GNU GPLv2
  Copyright 2012-2014
*/
#define VESA_DMTS_COUNT 0x51
struct dmt {
	/* pixels */
	uint32_t h;
	uint32_t h_bl; 
	uint32_t h_so;
	uint32_t h_spw;
	uint32_t h_b;
	uint32_t h_sp;		/* 0: high/positive, 1: low/negative */

	/* lines */
	uint32_t v;
	uint32_t v_bl; 
	uint32_t v_so;
	uint32_t v_spw;
	uint32_t v_b;
	uint32_t v_sp;		/* 0: high/positive, 1: low/negative */

	uint32_t pixel_clk;	/* kHz */
	uint32_t r;		/* Hz for timing name only */

	uint8_t interlaced;
	uint8_t reduced_blanking;
};

static struct dmt vesa_dmts[VESA_DMTS_COUNT] __attribute__ ((unused)) = {
	{
		.h			= 0,
		.h_bl			= 0, 
		.h_so			= 0,
		.h_spw			= 0,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 0,
		.v_bl			= 0, 
		.v_so			= 0,
		.v_spw			= 0,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 0,
		.r			= 0,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x01 */
		.h			= 640,
		.h_bl			= 192, 
		.h_so			= 672,
		.h_spw			= 64,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 350,
		.v_bl			= 95, 
		.v_so			= 382,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 31500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x02 */
		.h			= 640,
		.h_bl			= 192, 
		.h_so			= 672,
		.h_spw			= 64,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 400,
		.v_bl			= 45, 
		.v_so			= 401,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 31500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x03 */
		.h			= 720,
		.h_bl			= 216, 
		.h_so			= 756,
		.h_spw			= 72,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 400,
		.v_bl			= 46, 
		.v_so			= 401,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 35500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x04 */
		.h			= 640,
		.h_bl			= 144, 
		.h_so			= 656,
		.h_spw			= 96,
		.h_b			= 8,
		.h_sp			= 1,
		.v			= 480,
		.v_bl			= 29, 
		.v_so			= 490,
		.v_spw			= 2,
		.v_b			= 8,
		.v_sp			= 1,
		.pixel_clk		= 25175,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x05 */
		.h			= 640,
		.h_bl			= 176, 
		.h_so			= 664,
		.h_spw			= 40,
		.h_b			= 8,
		.h_sp			= 1,
		.v			= 480,
		.v_bl			= 24, 
		.v_so			= 489,
		.v_spw			= 3,
		.v_b			= 8,
		.v_sp			= 1,
		.pixel_clk		= 31500,
		.r			= 72,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x06 */
		.h			= 640,
		.h_bl			= 200, 
		.h_so			= 656,
		.h_spw			= 64,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 480,
		.v_bl			= 20, 
		.v_so			= 481,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 31500,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x07 */
		.h			= 640,
		.h_bl			= 192, 
		.h_so			= 696,
		.h_spw			= 56,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 480,
		.v_bl			= 29, 
		.v_so			= 481,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 36000,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x08 */
		.h			= 800,
		.h_bl			= 224, 
		.h_so			= 824,
		.h_spw			= 72,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 600,
		.v_bl			= 25, 
		.v_so			= 601,
		.v_spw			= 2,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 36000,
		.r			= 56,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x09 */
		.h			= 800,
		.h_bl			= 256, 
		.h_so			= 840,
		.h_spw			= 128,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 600,
		.v_bl			= 28, 
		.v_so			= 601,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 40000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x0a */
		.h			= 800,
		.h_bl			= 240, 
		.h_so			= 856,
		.h_spw			= 120,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 600,
		.v_bl			= 66, 
		.v_so			= 637,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 50000,
		.r			= 72,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x0b */
		.h			= 800,
		.h_bl			= 256, 
		.h_so			= 816,
		.h_spw			= 80,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 600,
		.v_bl			= 25, 
		.v_so			= 601,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 49500,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x0c */
		.h			= 800,
		.h_bl			= 248, 
		.h_so			= 832,
		.h_spw			= 64,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 600,
		.v_bl			= 31, 
		.v_so			= 601,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 56250,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x0d */
		.h			= 800,
		.h_bl			= 160, 
		.h_so			= 848,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 600,
		.v_bl			= 36, 
		.v_so			= 603,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 73250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x0e */
		.h			= 848,
		.h_bl			= 240, 
		.h_so			= 864,
		.h_spw			= 112,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 480,
		.v_bl			= 37, 
		.v_so			= 486,
		.v_spw			= 8,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 33750,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x0f */
		.h			= 1024,
		.h_bl			= 240, 
		.h_so			= 1032,
		.h_spw			= 176,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 24, 
		.v_so			= 768,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 44900,
		.r			= 43,
		.interlaced		= 1,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x10 */
		.h			= 1024,
		.h_bl			= 320, 
		.h_so			= 1048,
		.h_spw			= 136,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 768,
		.v_bl			= 38, 
		.v_so			= 771,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 65000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x11 */
		.h			= 1024,
		.h_bl			= 304, 
		.h_so			= 1048,
		.h_spw			= 136,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 768,
		.v_bl			= 38, 
		.v_so			= 771,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 75000,
		.r			= 70,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x12 */
		.h			= 1024,
		.h_bl			= 288, 
		.h_so			= 1040,
		.h_spw			= 96,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 32, 
		.v_so			= 769,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 78750,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x13 */
		.h			= 1024,
		.h_bl			= 352, 
		.h_so			= 1072,
		.h_spw			= 96,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 40, 
		.v_so			= 769,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 94500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x14 */
		.h			= 1024,
		.h_bl			= 160, 
		.h_so			= 1072,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 45, 
		.v_so			= 771,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 115500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x15 */
		.h			= 1152,
		.h_bl			= 448, 
		.h_so			= 1216,
		.h_spw			= 128,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 864,
		.v_bl			= 36, 
		.v_so			= 865,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 108000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x16 */
		.h			= 1280,
		.h_bl			= 160, 
		.h_so			= 1328,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 22, 
		.v_so			= 771,
		.v_spw			= 7,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 68250,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x17 */
		.h			= 1280,
		.h_bl			= 384, 
		.h_so			= 1344,
		.h_spw			= 128,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 768,
		.v_bl			= 30, 
		.v_so			= 771,
		.v_spw			= 7,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 79500,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x18 */
		.h			= 1280,
		.h_bl			= 416, 
		.h_so			= 1360,
		.h_spw			= 128,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 768,
		.v_bl			= 37, 
		.v_so			= 771,
		.v_spw			= 7,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 102250,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x19 */
		.h			= 1280,
		.h_bl			= 432, 
		.h_so			= 1360,
		.h_spw			= 136,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 768,
		.v_bl			= 41, 
		.v_so			= 771,
		.v_spw			= 7,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 117500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x1a */
		.h			= 1280,
		.h_bl			= 160, 
		.h_so			= 1328,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 45, 
		.v_so			= 771,
		.v_spw			= 7,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 140250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x1b */
		.h			= 1280,
		.h_bl			= 160, 
		.h_so			= 1328,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 800,
		.v_bl			= 23, 
		.v_so			= 803,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 71000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x1c */
		.h			= 1280,
		.h_bl			= 400, 
		.h_so			= 1352,
		.h_spw			= 128,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 800,
		.v_bl			= 31, 
		.v_so			= 803,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 83500,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x1d */
		.h			= 1280,
		.h_bl			= 416, 
		.h_so			= 1360,
		.h_spw			= 128,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 800,
		.v_bl			= 38, 
		.v_so			= 803,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 106500,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x1e */
		.h			= 1280,
		.h_bl			= 432, 
		.h_so			= 1360,
		.h_spw			= 136,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 800,
		.v_bl			= 43, 
		.v_so			= 803,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 122500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x1f */
		.h			= 1280,
		.h_bl			= 160, 
		.h_so			= 1328,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 800,
		.v_bl			= 47, 
		.v_so			= 803,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 146250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x20 */
		.h			= 1280,
		.h_bl			= 520, 
		.h_so			= 1376,
		.h_spw			= 112,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 960,
		.v_bl			= 40, 
		.v_so			= 961,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 108000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x21 */
		.h			= 1280,
		.h_bl			= 448, 
		.h_so			= 1344,
		.h_spw			= 160,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 960,
		.v_bl			= 51, 
		.v_so			= 961,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 148500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x22 */
		.h			= 1280,
		.h_bl			= 160, 
		.h_so			= 1328,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 960,
		.v_bl			= 57, 
		.v_so			= 963,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 175500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x23 */
		.h			= 1280,
		.h_bl			= 408, 
		.h_so			= 1328,
		.h_spw			= 112,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1024,
		.v_bl			= 42, 
		.v_so			= 1025,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 108000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x24 */
		.h			= 1280,
		.h_bl			= 408, 
		.h_so			= 1296,
		.h_spw			= 144,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1024,
		.v_bl			= 42, 
		.v_so			= 1025,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 135000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0 
	},
	{/* DMT ID 0x25 */
		.h			= 1280,
		.h_bl			= 448, 
		.h_so			= 1344,
		.h_spw			= 160,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1024,
		.v_bl			= 48, 
		.v_so			= 1025,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 157500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x26 */
		.h			= 1280,
		.h_bl			= 160, 
		.h_so			= 1328,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1024,
		.v_bl			= 60, 
		.v_so			= 1027,
		.v_spw			= 7,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 187250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x27 */
		.h			= 1360,
		.h_bl			= 432, 
		.h_so			= 1424,
		.h_spw			= 112,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 27, 
		.v_so			= 771,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 85500,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x28 */
		.h			= 1360,
		.h_bl			= 160, 
		.h_so			= 1408,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 768,
		.v_bl			= 45, 
		.v_so			= 771,
		.v_spw			= 5,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 148250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x29 */
		.h			= 1400,
		.h_bl			= 160, 
		.h_so			= 1448,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1050,
		.v_bl			= 30, 
		.v_so			= 1053,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 101000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x2a */
		.h			= 1400,
		.h_bl			= 464, 
		.h_so			= 1488,
		.h_spw			= 144,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1050,
		.v_bl			= 39, 
		.v_so			= 1053,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 121750,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x2b */
		.h			= 1400,
		.h_bl			= 496, 
		.h_so			= 1504,
		.h_spw			= 144,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1050,
		.v_bl			= 49, 
		.v_so			= 1053,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 156000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x2c */
		.h			= 1400,
		.h_bl			= 512, 
		.h_so			= 1504,
		.h_spw			= 152,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1050,
		.v_bl			= 55, 
		.v_so			= 1053,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 179500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x2d */
		.h			= 1400,
		.h_bl			= 160, 
		.h_so			= 1448,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1050,
		.v_bl			= 62, 
		.v_so			= 1053,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 208000,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x2e */
		.h			= 1440,
		.h_bl			= 160, 
		.h_so			= 1488,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 900,
		.v_bl			= 26, 
		.v_so			= 903,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 88750,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x2f */
		.h			= 1440,
		.h_bl			= 464, 
		.h_so			= 1520,
		.h_spw			= 152,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 900,
		.v_bl			= 34, 
		.v_so			= 903,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 106500,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x30 */
		.h			= 1440,
		.h_bl			= 496, 
		.h_so			= 1536,
		.h_spw			= 152,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 900,
		.v_bl			= 42, 
		.v_so			= 903,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 136750,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x31 */
		.h			= 1440,
		.h_bl			= 512, 
		.h_so			= 1544,
		.h_spw			= 152,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 900,
		.v_bl			= 48, 
		.v_so			= 903,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 157000,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x32 */
		.h			= 1440,
		.h_bl			= 160, 
		.h_so			= 1488,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 900,
		.v_bl			= 53, 
		.v_so			= 903,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 182750,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x33 */
		.h			= 1600,
		.h_bl			= 560, 
		.h_so			= 1664,
		.h_spw			= 192,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 50, 
		.v_so			= 1201,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 162000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x34 */
		.h			= 1600,
		.h_bl			= 560, 
		.h_so			= 1664,
		.h_spw			= 192,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 50, 
		.v_so			= 1201,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 175500,
		.r			= 65,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x35 */
		.h			= 1600,
		.h_bl			= 560, 
		.h_so			= 1664,
		.h_spw			= 192,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 50, 
		.v_so			= 1201,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 189000,
		.r			= 70,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x36 */
		.h			= 1600,
		.h_bl			= 560, 
		.h_so			= 1664,
		.h_spw			= 192,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 50, 
		.v_so			= 1201,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 202500,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x37 */
		.h			= 1600,
		.h_bl			= 560, 
		.h_so			= 1664,
		.h_spw			= 192,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 50, 
		.v_so			= 1201,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 229500,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x38 */
		.h			= 1600,
		.h_bl			= 160, 
		.h_so			= 1648,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 71, 
		.v_so			= 1203,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 268250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x39 */
		.h			= 1680,
		.h_bl			= 160, 
		.h_so			= 1728,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1050,
		.v_bl			= 30, 
		.v_so			= 1053,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 119000,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x3a */
		.h			= 1680,
		.h_bl			= 560, 
		.h_so			= 1784,
		.h_spw			= 176,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1050,
		.v_bl			= 39, 
		.v_so			= 1053,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 146250,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x3b */
		.h			= 1680,
		.h_bl			= 592, 
		.h_so			= 1800,
		.h_spw			= 176,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1050,
		.v_bl			= 49, 
		.v_so			= 1053,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 187000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x3c */
		.h			= 1680,
		.h_bl			= 608, 
		.h_so			= 1808,
		.h_spw			= 176,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1050,
		.v_bl			= 55, 
		.v_so			= 1053,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 214750,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x3d */
		.h			= 1680,
		.h_bl			= 160, 
		.h_so			= 1728,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1050,
		.v_bl			= 62, 
		.v_so			= 1053,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 245500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x3e */
		.h			= 1792,
		.h_bl			= 656, 
		.h_so			= 1920,
		.h_spw			= 200,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1344,
		.v_bl			= 50, 
		.v_so			= 1345,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 204750,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x3f */
		.h			= 1792,
		.h_bl			= 664, 
		.h_so			= 1888,
		.h_spw			= 216,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1344,
		.v_bl			= 73, 
		.v_so			= 1345,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 261000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x40 */
		.h			= 1792,
		.h_bl			= 160, 
		.h_so			= 1840,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1344,
		.v_bl			= 79, 
		.v_so			= 1347,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 333250,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x41 */
		.h			= 1856,
		.h_bl			= 672, 
		.h_so			= 1952,
		.h_spw			= 224,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1392,
		.v_bl			= 47, 
		.v_so			= 1393,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 218250,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x42 */
		.h			= 1856,
		.h_bl			= 704, 
		.h_so			= 1984,
		.h_spw			= 224,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1392,
		.v_bl			= 108, 
		.v_so			= 1393,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 288000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x43 */
		.h			= 1856,
		.h_bl			= 160, 
		.h_so			= 1904,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1392,
		.v_bl			= 82, 
		.v_so			= 1395,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 356500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x44 */
		.h			= 1920,
		.h_bl			= 160, 
		.h_so			= 1968,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 35, 
		.v_so			= 1203,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 154000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x45 */
		.h			= 1920,
		.h_bl			= 672, 
		.h_so			= 2056,
		.h_spw			= 200,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1200,
		.v_bl			= 45, 
		.v_so			= 1203,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 193250,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x46 */
		.h			= 1920,
		.h_bl			= 688, 
		.h_so			= 2056,
		.h_spw			= 208,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1200,
		.v_bl			= 55, 
		.v_so			= 1203,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 245250,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x47 */
		.h			= 1920,
		.h_bl			= 704, 
		.h_so			= 2064,
		.h_spw			= 208,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1200,
		.v_bl			= 62, 
		.v_so			= 1203,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 281250,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x48 */
		.h			= 1920,
		.h_bl			= 160, 
		.h_so			= 1968,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1200,
		.v_bl			= 71, 
		.v_so			= 1203,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 317000,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x49 */
		.h			= 1920,
		.h_bl			= 680, 
		.h_so			= 2048,
		.h_spw			= 208,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1440,
		.v_bl			= 60, 
		.v_so			= 1441,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 234000,
		.r			= 60,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x4a */
		.h			= 1920,
		.h_bl			= 720, 
		.h_so			= 2064,
		.h_spw			= 224,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1440,
		.v_bl			= 60, 
		.v_so			= 1441,
		.v_spw			= 3,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 297000,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x4b */
		.h			= 1920,
		.h_bl			= 160, 
		.h_so			= 1968,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1440,
		.v_bl			= 85, 
		.v_so			= 1443,
		.v_spw			= 4,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 380500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x4c */
		.h			= 2560,
		.h_bl			= 160, 
		.h_so			= 2608,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1600,
		.v_bl			= 46, 
		.v_so			= 1603,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 268500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	},
	{/* DMT ID 0x4d */
		.h			= 2560,
		.h_bl			= 944, 
		.h_so			= 2752,
		.h_spw			= 280,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1600,
		.v_bl			= 58, 
		.v_so			= 1603,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 348500,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x4e */
		.h			= 2560,
		.h_bl			= 976, 
		.h_so			= 2768,
		.h_spw			= 280,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1600,
		.v_bl			= 72, 
		.v_so			= 1603,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 443250,
		.r			= 75,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x4f */
		.h			= 2560,
		.h_bl			= 976, 
		.h_so			= 2768,
		.h_spw			= 280,
		.h_b			= 0,
		.h_sp			= 1,
		.v			= 1600,
		.v_bl			= 82, 
		.v_so			= 1603,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 0,
		.pixel_clk		= 505250,
		.r			= 85,
		.interlaced		= 0,
		.reduced_blanking	= 0
	},
	{/* DMT ID 0x50 */
		.h			= 2560,
		.h_bl			= 160, 
		.h_so			= 2608,
		.h_spw			= 32,
		.h_b			= 0,
		.h_sp			= 0,
		.v			= 1600,
		.v_bl			= 94, 
		.v_so			= 1603,
		.v_spw			= 6,
		.v_b			= 0,
		.v_sp			= 1,
		.pixel_clk		= 552750,
		.r			= 120,
		.interlaced		= 0,
		.reduced_blanking	= 1
	}
};
#endif
